classdef aghForest
    properties%(Access = private)
        trees;
    end
    
    
    methods
        function obj=aghForest(type,varargin)
            if isequal(type,'liste')
                obj.trees=varargin{1};
            elseif isequal(type,'concat')
                F1=varargin{1};
                F2=varargin{2};
                obj.trees=[F1.trees F2.trees];
            elseif isequal(type,'FixedSizeConditionedGW')
                
                cellR=readCell('TreesSize');
                I=find(cellR(varargin)==1);
                if length(I)>1
                    error('Parameters problem')
                end
                node=varargin{I+1};
                cellR=readCell('ForestSize');
                I=find(cellR(varargin)==1);
                if length(I)>1
                    error('Parameters problem')
                end
                fSize=varargin{I+1};
                cellR=readCell('Distribution');
                I=find(cellR(varargin)==1);
                if length(I)>1
                    error('Parameters problem')
                end
                p=varargin{I+1};
                T=[];
                for i=1:fSize
                    T=[T aghTree('ConditionnedGW',node,p)];
                end
                obj.trees=T;
                
            elseif isequal(type,'RandomSizeConditionnedGW')
                if (isequal(varargin{1},'TreeSize')&&isequal(varargin{3},'ForestSize')&&isequal(varargin{5},'Range'))
                    node=varargin{2};
                    fSize=varargin{4};
                    range=varargin{6};
                elseif (isequal(varargin{1},'TreeSize')&&isequal(varargin{5},'ForestSize')&&isequal(varargin{3},'Range'))
                    node=varargin{2};
                    fSize=varargin{6}; 
                    range=varargin{4};      
                elseif (isequal(varargin{3},'TreeSize')&&isequal(varargin{1},'ForestSize')&&isequal(varargin{5},'Range'))
                    node=varargin{4};
                    fSize=varargin{2}; 
                    range=varargin{6};      
                elseif (isequal(varargin{3},'TreeSize')&&isequal(varargin{5},'ForestSize')&&isequal(varargin{1},'Range'))
                    node=varargin{4};
                    fSize=varargin{6};       
                    range=varargin{2};           
                elseif (isequal(varargin{5},'TreeSize')&&isequal(varargin{1},'ForestSize')&&isequal(varargin{3},'Range'))
                    node=varargin{6};
                    fSize=varargin{2}; 
                    range=varargin{4};         
                elseif (isequal(varargin{5},'TreeSize')&&isequal(varargin{3},'ForestSize')&&isequal(varargin{1},'Range'))
                    node=varargin{6};
                    fSize=varargin{4}; 
                    range=varargin{2};
                else
                    error('Unconsistant parameters');
                end
                T=[];
                for i=1:fSize
                    T=[T aghTree('ConditionnedGW',randi(range))];
                end
                obj.trees=T;

            
            elseif isequal(type,'List');
                obj.trees=varargin{1};
            else
                error('Unknown arguments');
            end
                
        end

        function y=getMeanContour(obj)
            nTrees=length(obj.trees);
            
        end
        function y=getForestSize(obj)
           y=length(obj.trees); 
        end
        function T=getTree(obj,i)
            T=obj.trees(i);
        end

        function printForest(obj)
           nTrees=length(obj.trees);
           X=[];
           Y=[];
           for i=1:nTrees
              x=obj.trees(i).getContour;
              y=0:1:length(x)-1;
              if isempty(Y)
                 Y=[y]; 
              else
                  Y=[Y Y(end)+y];
              end
              X=[X x];
           end
          
           plot(Y,X);
           
        end
        function y=estimateScale(obj,varargin)
            cellR=readCell('KPDRV');
            kpdrv=sum(cellR(varargin));
            cellR=readCell('Wasserstein');
            wass=sum(cellR(varargin));
            cellR=readCell('LSE');
            lse=sum(cellR(varargin));
            if (lse>0&&wass>0)||(lse>0&&kpdrv>0)||(wass>0&&kpdrv>0)
               error('Only one estimation option is allowed'); 
            end
            if kpdrv>0
            cellR=readCell('useBiasCorrection');
            if sum(cellR(varargin))>0
                load('biasCorrector');
                biasCor=f;
                n=length(obj.trees);
                sigmas=zeros(1,n);
                
                for i=1:n
                    
                       T=obj.getTree(i);
                       nodes=T.getNodeHeights; 
                       N=length(nodes);
                       selected=randi(N);
                       sigmas(i)=nodes(selected)/(biasCor(T.getSize)*sqrt(T.getSize));
             
                end
                cellR=readCell('Elementswise');
                if sum(cellR(varargin))==0
                     y=sqrt(2/pi)*sum(sigmas)/n;
                else
                     y=sqrt(2/pi)*sigmas;
                end
 		    	
            else
                n=length(obj.trees);
                sigmas=zeros(1,n);
                
                for i=1:n
                    
                       T=obj.getTree(i);
                       nodes=T.getNodeHeights; 
                       N=length(nodes);
                       selected=randi(N);
                       sigmas(i)=nodes(selected)/sqrt(T.getSize);
             
                end
                cellR=readCell('Elementswise');
                if sum(cellR(varargin))==0
                     y=sqrt(2/pi)*sum(sigmas)/n;
                else
                     y=sqrt(2/pi)*sigmas;
                end
            end
		
	    elseif lse>0
            cellR=readCell('useBiasCorrection');
            if sum(cellR(varargin))>0
			    n=length(obj.trees);
			    sigmas=zeros(1,n);
			    load('biasCorrector');
                biasCor=f;
                f=@(x) sqrt(x.*(1-x))*4/sqrt(2*pi);
			    renorm=integral(@(x) f(x).^2,0,1);
				for i=1:n
				    
				    [x,y]=obj.getTree(i).getRContour;
				    y=y/biasCor(obj.getTree(i).getSize);
				    C=linF(x,y);
				    sigmas(i)=C.scalarProdGW()/renorm;
				end
			cellR=readCell('Elementswise');
            if sum(cellR(varargin))==0
                y=sum(sigmas)/(2*n);
            else
                y=sigmas/2;
            end
            else
                n=length(obj.trees);
                sigmas=zeros(1,n);
                f=@(x) sqrt(x.*(1-x))*4/sqrt(2*pi);
                renorm=integral(@(x) f(x).^2,0,1);
                for i=1:n
                    [a,b]=obj.getTree(i).getRContour;
                    C=linF(a,b);
                    sigmas(i)=C.scalarProdGW()/renorm;
                end
                cellR=readCell('Elementswise');
                if sum(cellR(varargin))==0
                    y=sum(sigmas)/(2*n);
                else
                    y=sigmas/2;
                end
    
            end

	   elseif wass>0
		cellR=readCell('useBiasCorrection');
            if sum(cellR(varargin))>0
		    n=length(obj.trees);
		    load('distEst');
		    poid=computeWassterteinWeight(n);
		    sigmas=zeros(1,n);
		    	load('biasCorrector');
                biasCor=f;
                f=@(x) sqrt(x.*(1-x))*4/sqrt(2*pi);
			    renorm=integral(@(x) f(x).^2,0,1);
		    for i=1:n
			    
			    [x,e]=obj.getTree(i).getRContour;
			    e=e/biasCor(obj.getTree(i).getSize);
			    C=linF(x,e);
			    sigmas(i)=C.scalarProdGW()/renorm;
            end
		    y=sum(sort(sigmas).*poid)/2;
		else
		    n=length(obj.trees);
		    load('distEst');
		    poid=computeWassterteinWeight(n);
		    sigmas=zeros(1,n);
		    f=@(x) sqrt(x.*(1-x))*4/sqrt(2*pi);
		    renorm=integral(@(x) f(x).^2,0,1);

		    for i=1:n
			[a,b]=obj.getTree(i).getRContour;
			C=linF(a,b);
			sigmas(i)=C.scalarProdGW()/renorm;
		    end
		    
            cellR=readCell('Elementswise');
                if sum(cellR(varargin))==0
                    y=sum(sort(sigmas).*poid)/2;
                else
                    error('Elementswise do not really makes sens in the case of Wasserstein method');
                end
        end
            else
                error('Unknown parameters');
	    end
            
            
        end
    end
end
