classdef aghTree<handle
    properties%(Access = private)
        subtrees;
    end
    
    
    methods
        function obj=aghTree(varargin)
            if nargin==0  
                
            elseif isequal('childsList',varargin{1})
                obj=childListToTree(varargin{2});
            elseif isequal('LukasWalk',varargin{1})
                obj=lukaswalkToTree(varargin{2});
            elseif isequal('GaltonWatson',varargin{1})
                obj=randomGW(varargin{1});
            elseif isequal('ConditionnedGW',varargin{1})
                obj=conditionnedGaltonWatson(varargin{2},varargin{3});
            elseif isequal('Contour',varargin{1})
                obj=contourToTree(varargin{2});
            elseif isequal('Webpage',varargin{1})
                URL=varargin{2};
                contour=urlToTree(URL);
                obj=aghTree('Contour',contour);
                
            end  
        end
        function b=saveobj(a)
            b=a.getChildsList;
        end
        function addtree(obj,tree)
            if obj.numbChild == 0
                obj.subtrees = tree();
            else
                obj.subtrees = [obj.subtrees tree];
            end
        end
        function addchildren(obj)
            t=tree();
            obj.addtree(t);
        end
        
        function y=numbChild(obj)
            y=length(obj.subtrees);
        end
        function y=getChild(obj,i)
            y=obj.subtrees(i);
        end
        function y=getSize(obj)
            nChilds=obj.numbChild;
            if nChilds==0
                y=1;
            else
                sum=1;
                for i=1:nChilds
                    arbre=obj.getChild(i);
                    sum=sum+arbre.getSize;
                end
                y=sum;
            end
        end
        function y=getHeight(obj)
            nChilds=obj.numbChild;
            x=zeros(1,nChilds);
            if nChilds==0
                y=0;
            else
                for i=1:nChilds
                    x(i)=getHeight(obj.getChild(i));
                end
                y=max(x)+1;
            end
            
        end
        function y=getLeafNumber(obj)
           nChild=length(obj.subtrees);
           if nChild == 0
               y=1;
           else
               leaf=0;
               for i=1:nChild
                   leaf=leaf+obj.subtrees(i).getLeafNumber;
               end
               y=leaf;
           end
        end
        function y=getOuterDegree(obj)
            nChild=length(obj.subtrees);
            out=-1;
            for i=1:nChild
               out=max(out,obj.subtrees(i).getOuterDegree); 
            end
            y=max(nChild,out);
        end
        function y=getContour(obj)
            nChilds=obj.numbChild;
            if nChilds==0
                y=0;
            else
                temp=[];
                for i=1:nChilds
                    sub=obj.getChild(i);
                    temp=[temp 0 (sub.getContour+1)];
                    y=[temp 0];
                end
            end 
            
        end
        function y=Vect(obj)
            n=obj.numbChild;
            if n==0
                y=[];
            else
                temp=[];
                nprime=1;
                for i=1:n
                    arbre=obj.getChild(i);
                    toadd=arbre.Vect;
                    toadd=[1 (toadd(2:end)+nprime)];
                    temp=[temp toadd];
                    nprime=nprime+arbre.getSize;
                    
                    
                    
                end
                y=[0 temp];
            end
            
        end
        function plotContour(obj)
            con=obj.getContour;
            n=obj.getSize;
            x=[0:1:2*n-2];
            y=con;
            plot(x,y)
        end
        function walk_on_max(obj)
            childs = obj.subtrees;
            n = length(childs);
            size=[];
            for i=1:n
                size=[size childs(i).height];
                childs(i).walk_on_max();
            end
            [g,I]=sort(size);
            obj.subtrees = childs(I);
        end
        function y=getChildsList(obj)
                liste=[];
                enfant = obj.subtrees;
                nchild = length(enfant);
                if nchild>0
                    liste=[liste nchild];
                    for i=1:nchild
                        liste=[liste enfant(i).getChildsList()];
                    end
                    y=liste;
                else
                    liste=[0];
                end
                y=liste;
                
        end
        function y=getLuka(obj)
            c=obj.getChildsList();
            c=c-1;
            y=[0 cumsum(c)];
        end
        function [a,b]=getRContour(obj)
            H=obj.getContour;
            a=(0:1:length(H)-1)/(length(H)-1);
            b=H/sqrt(obj.getSize);
        end
        function y=getWidth(obj)
            nChild=length(obj.subtrees);
                Liste=obj.subtrees;
                w=max(1,nChild);
                while ~isempty(Liste)
                    newListe=[];
                    for i=1:nChild
                        newListe=[newListe Liste(i).subtrees];
                    end
                    Liste=newListe;
                    nChild=length(newListe);
                    w=max(w,nChild);
                end
                y=w;
        end
        function plotTree(obj,varargin)
            
            if nargin > 1
                lowerBound=varargin{1};
                upperBound=varargin{2};
                gen=varargin{3};
            else
                fig=gcf;
%                 set(gca,'XLim',[-2*obj.getWidth 2*obj.getWidth]);
%                 hold on;
%                 set(gca,'YLim',[-obj.height 0]);
                lowerBound=-obj.getWidth;
                upperBound=obj.getWidth;
                gen=0;
                
            end
           nchild=length(obj.subtrees);
           centre=(lowerBound+upperBound)/2;
           taille=upperBound-lowerBound;
           rate=0;
           if nchild>0
           for i=1:nchild
               rate=rate+obj.getChild(i).getWidth;
           end
           gauche=lowerBound;
           droite=lowerBound+taille*obj.getChild(i).getWidth/rate;
           for i=1:nchild
              plot([centre (gauche+droite)/2],[gen gen-1],'Color','blue');
              hold on;
              enf=obj.getChild(i);
              enf.plotTree(gauche,droite,gen-1);
              
              gauche=droite;
              if i<nchild
              droite=droite+taille*obj.getChild(i+1).getWidth/rate;
              end
           end
           end
            
        end

      function a=getLeafHeights(obj)
            child = obj.subtrees;
            n=length(child);
            if n==0
                a=[0];
            else
                res=[];
                for i=1:n
                    res=[res 1+child(i).getLeafHeights];
                end
                a=res;
            end
        end
        function a=getNodeHeights(obj)
            child = obj.subtrees;
            n=length(child);
            res=[0];
            if n>0
                
                for i=1:n
                    res=[res  1+child(i).getNodeHeights];
                end
                a=res;
            end
            a=res;
        end
    end
    
    methods (Static)
        function b=loadobj(a)
            b=aghTree('childsList',a);
        end
    end
end
