classdef linF
    
    properties(Access = private)
        Abscisses %Taille de la première branche
    end
    properties(Access = private)
        Values%Listes des enfants collés sur la première branche (pointeur)
    end


    methods
        function obj=linF(X,Y)%constructeur
            if length(X)~=length(Y)
                error('taille des vecteur n est pas cohérents');
            else
            obj.Abscisses=X;
            obj.Values=Y;
            end
        end
        function y=integral(obj)
            n=length(obj.Values);
            Int=0;
            for i=1:n-1
                Int=Int+(obj.Values(i+1)+obj.Values(i))*(obj.Abscisses(i+1)-obj.Abscisses(i))/2;
            end
            y=Int;
        end
        function y=squaredInt(obj)
                        n=length(obj.Values);
            Int=0;
            for i=1:n-1
                
                xi=obj.Abscisses(i);
                xip=obj.Abscisses(i+1);
                a=(obj.Values(i+1)-obj.Values(i))/(xip-xi);
                b=obj.Values(i)-xi*a;
                Int=Int+(a*a/3)*(xip^3-xi^3)+a*b*(xip^2-xi^2)+b*b*(xip-xi);
            end
            y=Int;
        end
        function y=eval(obj,x)
           i=1;

           if(x<min(obj.Abscisses))
               y=obj.Values(1);
           elseif(x>max(obj.Abscisses))
               y=obj.Values(end);
           else
               while obj.Abscisses(i)<x
                   i=i+1;
               end
               if obj.Abscisses(i)==x
                   
                   y=obj.Values(i);
               else
                   y=obj.Values(i-1)+(x-obj.Abscisses(i-1))*(obj.Values(i)-obj.Values(i-1))/(obj.Abscisses(i)-obj.Abscisses(i-1));
               end
           end
        end
        function Y=evalV(obj,x)
            n=length(x);
            rep=zeros(1,n);
            for i=1:n
                rep(i)=obj.fonc(x(i));
            end
            Y=rep;
        end
        function y=L2scalarProd(obj,f,a,b)
            if(min(obj.Abscisses)>a||max(obj.Abscisses)<b)
                error('Error: range of integration overcomes function support');
            else
              n=length(obj.Abscisses);
              sum=0;
              for i=1:n-1
                  linearF=@(x) (obj.Values(i)-obj.Values(i+1))/(obj.Abscisses(i)-obj.Abscisses(i+1))*(x-obj.Abscisses(i))+obj.Values(i);
                  sum=sum+integral(@(x) f(x).*linearF(x),obj.Abscisses(i),obj.Abscisses(i+1));
              end
              y=sum;
            end
        end
        function y=scalarProdGW(obj)
            p2=@(x) -0.25*(1-2*x)*sqrt(x*(1-x))+(1/8)*asin(2*x-1);
            p1=@(x) -(1/3)*(x*(1-x))^(3/2) -(1/8)*(1-2*x)*sqrt(x*(1-x))+(1/16)*asin(2*x-1);

              n=length(obj.Abscisses);
              sum=0;
              for i=1:n-1
                  rap=(obj.Values(i+1)-obj.Values(i))/(obj.Abscisses(i+1)-obj.Abscisses(i));
                  sum=sum+rap*(p1(obj.Abscisses(i+1))-p1(obj.Abscisses(i)));
                  sum=sum+(-rap*obj.Abscisses(i)+obj.Values(i))*(p2(obj.Abscisses(i+1))-p2(obj.Abscisses(i)));
              end
              y=4/sqrt(2*pi)*sum;
            
        end
        function x=ifonc(obj,y)
            stdErr=1e-5;
            f=@(x) obj.eval(x)-y;
            [sol,fval,flag,output]=fzero(f,obj.Abscisses(1));
            if flag == 1
                x=sol;
            else
                x=Inf;
            end
        end
        function GoodEta=getMass(obj,rho,pas,centre)
            eta=pas;
            mass=obj.fonc(centre+eta)-obj.fonc(centre-eta);
            while mass<rho&&eta<10
                eta=eta+pas;
%                 if(mass==obj.fonc(centre+eta)-obj.fonc(centre-eta))
%                     break;
%                 end
                mass=obj.fonc(centre+eta)-obj.fonc(centre-eta);
                
            end
            GoodEta=eta;
        end
        function [etaleft,etaright]=getAsymMass(obj,rho,pas,centre)
            posl=centre;
            posr=centre;
            mass=0;
            while mass<rho
                addAtRight=obj.fonc(posr+pas)-obj.fonc(posr);
                addAtLeft=obj.fonc(posl)-obj.fonc(posl-pas);
                if(addAtRight==addAtLeft)
                    posr=posr+pas;
                    posl=posl-pas;
                    mass=mass+addAtRight;
                    mass=mass+addAtLeft
                elseif(addAtRight>addAtLeft)
                    posr=posr+pas;
                    mass=mass+addAtRight;
                else
                    posl=posl-pas;
                    mass=mass+addAtLeft;
                end
            end
            etaleft=centre-posl;
            etaright=posr-centre;
        end
        function plot(obj)
            plot(obj.Abscisses,obj.Values);
        end
        function plotDist(obj)
            plot(obj.Abscisses(1:end-1),diff(obj.Values)/(obj.Abscisses(2)-obj.Abscisses(1)));
        end
        function x=mean(obj)
            toInt=1-obj.Values;
            x=sum(toInt(obj.Abscisses>0))*(obj.Abscisses(2)-obj.Abscisses(1));
        end
    end
end
